# 环境

> 原文：[https://rpy2.readthedocs.io/en/version_2.8.x/robjects_environments.html](https://rpy2.readthedocs.io/en/version_2.8.x/robjects_environments.html)

对于 Python 用户来说，R 环境可以描述为字典和作用域的混合体。

所有环境中的第一个称为全局环境，也可以称为 R 工作区。

RPY2 中的 R 环境可以看作是一种 Python 字典。

将值赋给环境中的符号已经变得和将值赋给 Python 字典中的键一样简单：

```
>>> robjects.r.ls(globalenv)
>>> robjects.globalenv["a"] = 123
>>> print(robjects.r.ls(globalenv))

```

在将对象分配到环境（如全局环境）时必须小心，因为这样可以隐藏具有相同名称的其他对象。以下示例应制定一个措施，即如果不小心，这可能意味着麻烦：

```
>>> globalenv["pi"] = 123
>>> print(robjects.r.pi)
[1] 123
>>>
>>> robjects.r.rm("pi")
>>> print(robjects.r.pi)
[1] 3.1415926535897931

```

类继承自类`rpy2.rinterface.SexpEnvironment`。

环境也可以是 iter，返回它包含的所有符号（键）：

```
>>> env = robjects.r.baseenv()
>>> [x for x in env]
<a long list returned>

```

注意

尽管环境和 R 包之间存在自然的联系，但是应该考虑使用专用于 R 型包的便利包装器（请参见[R 包](robjects_rpackages.html#robjects-packages)）。