> 原文：[https://rpy2.readthedocs.io/en/version_2.8.x/rhelp.html](https://rpy2.readthedocs.io/en/version_2.8.x/rhelp.html)

# R 帮助

`R`有一个文档系统，确保在安装包时安装作为包分发的代码的文档。可以从 R 本身调用和搜索此文档。

与`Python`docstrings 不同，在特殊属性`__doc__`中可以找到文档字符串，r 文档位于文档页面中对象之外。每个文档页面至少关联一个`alias`，别名通常对应于包（函数、数据集等）中定义的 R 对象的名称。

例如，查询 r 函数`sum`的文档就变成了查找哪个文档页具有别名`sum`并检索该页的问题。

## 查询别名

使用 R 时，使用文档的常见用例是查询别名（函数名、数据集或类名）并检索相关的文档。

虽然 R 打包系统将检查任何给定的别名是否只与同一个包中的一个页面关联，但很可能有多个包为同一别名定义文档页面。

通过 rpy2 与帮助系统的接口，检索与别名关联的页面的一个简单方法是使用函数`pages()`，该函数返回`tuple`个实例。

## 程序包文档

包的文档用类`Package`表示。

```
>>> import rpy2.robjects.help as rh
>>> base_help = rh.Package('base')
>>> base_help.fetch('sum')

```

## 文档页

文档页表示为类`Page`的实例。

```
>>> hp = base_help.fetch('sum')

```

```
>>> hp.sections.keys()
('title', 'name', 'alias', 'keyword', 'description', 'usage', 'arguments', 'deta
ils', 'value', 'section', 'references', 'seealso')

```

注意

```
>>> print(''.join(hp.to_docstring(('details',))))

```

```
details
-------

   This is a generic function: methods can be defined for it
   directly or via the  Summary  group generic.
   For this to work properly, the arguments   should be
   unnamed, and dispatch is on the first argument.

   If  na.rm  is  FALSE  an  NA
   value in any of the arguments will cause
   a value of  NA  to be returned, otherwise
   NA  values are ignored.

   Logical true values are regarded as one, false values as zero.
   For historical reasons,  NULL  is accepted and treated as if it
   were  integer(0) .

```