# 入门

> 原文：[https://rpy2.readthedocs.io/en/version_2.8.x/getting-started.html](https://rpy2.readthedocs.io/en/version_2.8.x/getting-started.html)

*   [概述](overview.html)
    *   [背景](overview.html#background)
    *   [安装](overview.html#installation)
        *   [Docker 图像](overview.html#docker-image)
            *   [IPython 控制台](overview.html#ipython-console)
            *   [Jupyter Notbook](overview.html#jupyter-notbook)
        *   [要求](overview.html#requirements)
            *   [可选的 python 实现](overview.html#alternative-python-implementations)
            *   [从旧版本的 rpy2 升级](overview.html#upgrading-from-an-older-release-of-rpy2)
        *   [下载](overview.html#download)
        *   [Linux 预编译二进制文件](overview.html#linux-precompiled-binaries)
        *   [Microsoft 的 Windows 预编译二进制文件](overview.html#microsoft-s-windows-precompiled-binaries)
        *   [从源安装](overview.html#install-from-source)
            *   [易于安装和 PIP](overview.html#easy-install-and-pip)
            *   [源存档](overview.html#source-archive)
            *   [在 Linux 上编译](overview.html#compiling-on-linux)
            *   [在 OS X 上编译](overview.html#compiling-on-os-x)
            *   [将 rpy2 与其他版本的 r 或 python](overview.html#using-rpy2-with-other-versions-of-r-or-python)一起使用
        *   [测试安装](overview.html#test-an-installation)
    *   [目录](overview.html#contents)
        *   [`rpy2.rinterface`](overview.html#rpy2-rinterface)
        *   [`rpy2.robjects`](overview.html#rpy2-robjects)
        *   [`rpy2.interactive`](overview.html#rpy2-interactive)
        *   [`rpy2.rpy_classic`](overview.html#rpy2-rpy-classic)
        *   [`rpy2.rlike`](overview.html#rpy2-rlike)
    *   [设计说明](overview.html#design-notes)
    *   [确认](overview.html#acknowledgements)
*   [RPY2 简介](introduction.html)
    *   [入门](introduction.html#getting-started)
    *   [R 包](introduction.html#r-packages)
        *   [导入包](introduction.html#importing-packages)
        *   [安装软件包](introduction.html#installing-packages)
    *   [实例`r`](introduction.html#the-r-instance)
        *   [获取 r 对象](introduction.html#getting-r-objects)
        *   [评估 R 代码](introduction.html#evaluating-r-code)
        *   [将 r 对象插入 r 代码字符串](introduction.html#interpolating-r-objects-into-r-code-strings)
    *   [r 向量](introduction.html#r-vectors)
        *   [创建 rpy2 向量](introduction.html#creating-rpy2-vectors)
    *   [调用 r 函数](introduction.html#calling-r-functions)
    *   [获取帮助](introduction.html#getting-help)
        *   [给定包或当前加载的包中的主题帮助](introduction.html#help-on-a-topic-within-a-given-package-or-currently-loaded-packages)
        *   [在可用包中定位主题](introduction.html#locate-topics-among-available-packages)
    *   [示例](introduction.html#examples)
        *   [图形和绘图](introduction.html#graphics-and-plots)
        *   [线性模型](introduction.html#linear-models)
        *   [主成分分析](introduction.html#principal-component-analysis)
        *   [创建一个 r 向量或矩阵，并使用 python 代码填充其单元格](introduction.html#creating-an-r-vector-or-matrix-and-filling-its-cells-using-python-code)
        *   [再举一个例子](introduction.html#one-more-example)