# 概述

> 原文：[https://rpy2.readthedocs.io/en/version_2.8.x/overview.html](https://rpy2.readthedocs.io/en/version_2.8.x/overview.html)

## 背景

[python](http://www.python.org)是一种流行的通用脚本语言，而[r](http://www.r-project.org)（S/SPlus 语言的开放源代码实现）是一种主要用于数据分析、统计和图形的脚本语言。如果你正在读这篇文章，你很有可能至少熟悉这两者之一。

在两种语言之间拥有一个接口以从一种语言的库中获益，而在另一种语言中工作似乎是可取的；实现这一点的早期选择是 rspython 项目，它本身是[omegahat 项目](http://www.omegahat.org/RSPython)的一部分。

稍后，RPY 项目出现了，它的重点是提供从 python 内部对 r 的简单而健壮的访问，最初的仅 Unix 版本很快就发布了，随后是与 Microsoft 和 MacOS 兼容的版本。在本文档的其余部分中，此项目称为 RPY-1.x。

本文件描述了 RPY2，一种 RPY-1.x 的演变。自然，RPY2 是由 RPY 启发的，但也受到了 A.Belopolsky 的贡献，这些贡献正等待纳入 RPY。

这项工作可以看作是对 RPY 包的重新设计和重写，不幸的是，这意味着没有足够的共同点来确保兼容性。

## 安装

### Docker 图像

有一个 Docker 映像可以在不考虑安装过程的情况下尝试 RPY2。

#### IPython 控制台

```
docker run -it --rm -p 8888:8888 \
       rpy2/rpy2:2.8.x ipython

```

#### 朱彼特 Notbook

要在端口 8888 上运行 Jupyter 笔记本：

```
docker run --rm -p 8888:8888 \
       rpy2/rpy2:2.8.x

```

启动后，将 Web 浏览器指向`http://localhost:8888`。

注意

如果使用`docker-machine`（在 Mac 或 Windows PC 上应该是这种情况），则不会是`localhost`。IP 地址将通过以下方式给出：

```
docker-machine ip [name-of-your-docker-machine-vm]

```

如果通常是关于 docker machine vm 的名称，请检查命令`docker-machine ls`的输出。

### 要求

目前，开发是在具有以下软件版本的类 Unix 操作系统上完成的。这些是运行 RPY2 的推荐版本。

<colgroup><col width="14%"> <col width="86%"></colgroup> 
| 软件 | 版本 |
| --- | --- |
| 蟒蛇 | 3.5，与 2.7 和 3.3 的预期兼容性 |
| R | 3.2+（低于 3.0 可能正常） |

运行 rpy2 需要为 r、python 和 readline 编译库；构建 rpy2 需要相应的开发头文件（有关构建 rpy2 的更多信息，请参阅文档）。

RPY2 几乎肯定不会使用 Python2.6。旧的 Python 版本甚至不太可能工作。

虽然 python 3.3 应该可以工作，但早期版本的 python3 不应该工作（它们可能工作，但它们可能不工作——您自己工作）。

RPY2 完全不适用于 R 版本&lt；2.8。不建议将最新的 RPY2 与比当前版本旧的 R 版本一起使用（而且大多数情况下不受支持）。

#### 可选的 python 实现

cpython 是目标实现，由于 rpy2 中存在 C 代码，所以目前无法在 jython 上运行包。出于同样的原因，使用 pypy 运行它需要一些努力。

#### 从旧版 RPY2 升级

为了升级，必须先删除较旧的已安装 RPY2 软件包，然后才安装 RPY2 版本。

要执行此操作，或检查是否安装了较早版本的 RPY2，请在 Python 控制台中执行以下操作：

```
import rpy2
rpy2.__path__

```

执行期间出错意味着您没有安装任何旧版本的 RPY2，您应该继续下一节。

如果返回包含路径的字符串，则应转到该路径并删除以 _rpy2_ 开头的所有文件和目录。要确保清理完成，请打开一个新的 python 会话并检查上面的代码是否会导致错误。

### 下载

以下选项可供下载：

> *   源程序包。发布的版本在 sourceforge 和 pypi 上都可用。开发版本的快照可以从 BitBucket 下载
>     
>     
>     
>     Note
>     
>     
>     
>     BitBucket 上的存储库有几个分支。一定要选择你感兴趣的那个。
>     
>     
> *   预编译的二进制包
>     
>     
>     *   Microsoft 的 Windows-非官方和不受支持的二进制文件由 Christoph Gohlke（[http://www.lfd.uci.edu/~gohlke/pythonlibs/](http://www.lfd.uci.edu/~gohlke/pythonlibs/)）提供；否则，目前几乎不支持此平台。
>     *   苹果的 MacOS X（虽然有 Fink 和 MacPorts 可用，但目前似乎没有二进制文件可用）
>     *   Linux 发行版

已报告在所有 3 个平台上成功编译了`rpy2`，前提是安装了开发项（如 python headers 和 C 编译器）。

Note

从`rpy2`包中选择文件，而不是`rpy`。

Note

可以使用 _pip_ 或 _easy-install_ 命令，尽管它们目前只提供源代码的安装（请参阅[easy-install 和 pip](#install-easyinstall)）。

### Linux 预编译二进制文件

Linux 发行版有打包系统，RPY2 存在于许多打包系统中，可以是预编译包，也可以是动态编译的源包。

Note

这些版本通常比最新的 RPY2 版本更旧。

已知分布有：Debian 和相关分布（如 Ubuntu——通常是最近的一次，这要归功于 Dirk Eddelbuettel）、Suse、Redhat、Mandrake、Gentoo。

在上，OS X RPY2 位于 MacPorts 和 Fink 中。

### Microsoft 的 Windows 预编译二进制文件

如果可用，可以运行可执行文件；这将在默认的 python 安装中安装包。

对于 2.0.x 系列中的少数几个版本，Microsoft Windows 二进制文件由 Predictix 的 Laurent Oget 提供。

目前没有二进制文件或对 Microsoft Windows 的支持（更多的是因为缺少资源而不是其他任何东西）。

### 从源安装

#### 易于安装和 PIP

源包位于 python 包索引（pypi）上，并且可以随时使用 _pip_ 或 _easy-install_ 脚本。shell 命令将只是：

```
# recommended:
pip install rpy2

# or
easy_install rpy2

```

升级现有安装是通过以下方式完成的：

```
      # recommended:
pip install rpy2 --upgrade

# or
easy_install rpy2 --upgrade

```

两个实用程序都有一个选项列表，应检查它们各自的文档以了解详细信息。

#### 源存档

要从下载的源归档文件`&lt;rpy_package&gt;`安装，请在 shell 中执行以下操作：

```
tar -xzf <rpy_package>.tar.gz
cd <rpy_package>
python setup.py build install

```

这将构建包，从路径中找到的 R 可执行文件猜测 R home。

除了[`distutils`](http://docs.python.org/library/distutils.html#module-distutils "(in Python v2.7)")构建和安装 python 包的常规选项之外，还可以明确给出 r home 的位置：

```
python setup.py build --r-home /opt/packages/R/lib install

```

构建包的其他选项包括：

```
--r-home-lib # for exotic location of the R shared libraries

--r-home-modules # for R shared modules

```

#### 在 Linux 上编译

考虑到上面列出了库和开发头，这应该是非常顺利的。

最常见的错误似乎是由于缺少头。

#### 在 OS X 上编译

为了编译 rpy2，需要 _xcode_ 工具。请参考苹果网站上的文档，了解更多关于它们是什么以及如何安装它们的详细信息。

在 OS X“雪豹”（10.6.8）上，据报告有时需要设置架构标志

```
env ARCHFLAGS="-arch i386 -arch x86_64" pip install rpy2

```

或

```
env ARCHFLAGS="-arch i386 -arch x86_64" python setup.py build install

```

有些人报告说 OS X“lion”有问题。如果你在这种情况下，请检查 bug 追踪器。

#### 将 rpy2 与其他版本的 r 或 python 一起使用

警告

构建 RPY2 时，会检查这是否与建议的 R 版本相对应。通过标记 _–忽略 check-r version_，可以针对不同的版本进行构建，尽管根本不受支持。

```
python setup.py build_ext --ignore-check-rversion install

```

自最近以来，开发 R 不再返回 R 版本，检查以错误“error:R&gt；=&lt；some version&gt；required（and R told‘development.’）”结束。然后需要标记 _–ignore check rversion_ 才能生成。

Note

从源代码处编译 r 时，不要忘记在 _ 步骤/configure_ 处指定 _–启用-r-shlib_。

### 测试安装

可以测试安装的功能，并且在必要时，可以独立测试组成软件包的不同层。

```
python -m 'rpy2.tests'

```

在 python 2.6 上，这应该返回所有测试都成功。

每当需要更多的细节时，可以考虑运行显式测试。

```
import rpy2.tests
import unittest

# the verbosity level can be increased if needed
tr = unittest.TextTestRunner(verbosity = 1)
suite = rpy2.tests.suite()
tr.run(suite)

```

Note

在交互会话中运行测试似乎会在测试引发异常的回调函数时触发假异常。如果不确定，只需使用前一种方法进行测试（在 shell 中）。

Warning

出于需要说明的原因，运行测试套件会使 Python 解释器处于脆弱状态，在测试运行后很快就会崩溃。

尚不清楚情况是否仍然如此，但建议在测试后终止 python 进程并开始使用新会话。

要测试[`rpy2.robjects`](robjects.html#module-rpy2.robjects "rpy2.robjects: High-level interface with R (Unix, Windows)")高级接口：

```
python -m 'rpy2.robjects.tests.__init__'

```

或者完全控制选项

```
import rpy2.robjects.tests
import unittest

# the verbosity level can be increased if needed
tr = unittest.TextTestRunner(verbosity = 1)
suite = rpy2.robjects.tests.suite()
tr.run(suite)

```

如果对较低级别的接口感兴趣，可以使用以下方法运行测试：

```
python -m 'rpy2.rinterface.tests.__init__'

```

or for a full control of options

```
import rpy2.rinterface.tests
import unittest

# the verbosity level can be increased if needed
tr = unittest.TextTestRunner(verbosity = 1)
suite = rpy2.rinterface.tests.suite()
tr.run(suite)

```

## 目录

包由多个子包或模块组成：

### [`rpy2.rinterface`](rinterface.html#module-rpy2.rinterface "rpy2.rinterface: Low-level interface with R (Unix, Windows)")

当速度和灵活性最重要时，与 R 的低级接口。接近 R 的 C 级 API。

### [`rpy2.robjects`](robjects.html#module-rpy2.robjects "rpy2.robjects: High-level interface with R (Unix, Windows)")

高级界面，在易用性最重要的时候。应该是休闲和一般用途的正确选择。基于上一个。

### [`rpy2.interactive`](interactive.html#module-rpy2.interactive "rpy2.interactive")

高层次的界面，以交互工作为中心。主要基于[`rpy2.robjects`](robjects.html#module-rpy2.robjects "rpy2.robjects: High-level interface with R (Unix, Windows)")。

### [`rpy2.rpy_classic`](rpy_classic.html#module-rpy2.rpy_classic "rpy2.rpy_classic: Emulate the orignal rpy")

与 rpy-1.x 中的接口类似的高级接口。这是为了兼容性的原因而提供的，并且便于迁移到 rpy2。

### [`rpy2.rlike`](rlike.html#module-rpy2.rlike "rpy2.rlike: Operate (a bit) like in R (Unix, Windows)")

在纯 python（无嵌入式 r 进程）中模拟 r 的一些特性和特性的数据结构和函数。

## 设计说明

在设计 RPY2 时，注意：

*   从 python 或 r 用户的角度简化模块的使用，
*   尽量减少对 R 知识的需要，以及对技巧和解决方法的需要，
*   允许在保持在 Python 级别的同时进行大量定制（不必降低到 C 级别）。

[`rpy2.robjects`](robjects.html#module-rpy2.robjects "rpy2.robjects: High-level interface with R (Unix, Windows)")通过扩展在[`rpy2.rinterface`](rinterface.html#module-rpy2.rinterface "rpy2.rinterface: Low-level interface with R (Unix, Windows)")中定义的带有子类的 r 对象的类来实现对接口的扩展。

选择继承是为了便于实现[`rpy2.rinterface`](rinterface.html#module-rpy2.rinterface "rpy2.rinterface: Low-level interface with R (Unix, Windows)")和[`rpy2.robjects`](robjects.html#module-rpy2.robjects "rpy2.robjects: High-level interface with R (Unix, Windows)")之间的大部分可交换类。例如，一个`rpy2.rinterface.SexpClosure`可以被赋予任何`rpy2.robjects.RObject`作为参数，而任何`rpy2.robjects.Function`可以被赋予任何[`rpy2.rinterface.Sexp`](rinterface.html#rpy2.rinterface.Sexp "rpy2.rinterface.Sexp")。由于 R 的功能基础，也存在类似容器的扩展。

模块[`rpy2.rpy_classic`](rpy_classic.html#module-rpy2.rpy_classic "rpy2.rpy_classic: Emulate the orignal rpy")正在使用委托，让我们演示如何用继承的替代方法扩展[`rpy2.rinterface`](rinterface.html#module-rpy2.rinterface "rpy2.rinterface: Low-level interface with R (Unix, Windows)")。

## 确认

对贡献、支持和早期测试的确认转到（按字母顺序排列）：

Alexander Belopolsky、Brad Chapman、Peter Cock、Dirk Eddelbuettel、Thomas Kluyver、Walter Moreira、Laurent Oget、John Owens、Nicolas Rapin、Grzegorz Slodkowicz、Nathaniel Smith、Gregory Warnes 以及 JRI 作者、R 作者、R 帮助列表响应者、麻木列表响应者和其他 con 论坛。