# 相关项目

> 原文：[https://rpy2.readthedocs.io/en/version_2.8.x/related_projects.html](https://rpy2.readthedocs.io/en/version_2.8.x/related_projects.html)

## 生物信息学

### 云计算

`rpy2`是[cloudbioLinux](http://cloudbiolinux.org/)提供的许多面向生物信息学的软件包之一。如果您正在考虑一个涉及云计算的项目，请查看它。

### 生物导体

生物导电体是一套很受欢迎的生物信息学 R 软件包。在项目[rpy2 bioconductor extensions](http://pypi.python.org/pypi/rpy2-bioconductor-extensions/0.2-dev)中，该项目中定义的许多类通过 rpy2 公开为 python 类。生物导体项目的发展非常迅速，绘图可能不再有效。

Brad Chapman 的[博客还提供了一些很好的例子，说明如何将`rpy2`用于生物信息学任务（或一般的 python 用于生物信息学）。](http://bcbio.wordpress.com/)

## 交互式控制台

数据分析师通常喜欢以交互方式工作，即经历以下短周期：

*   编写一点代码，这主要涉及对现有函数的调用。
*   运行该代码
*   检查结果，通常使用绘图和图形

R 用户将特别熟悉这种方法，并且在使用`rpy2`时可能需要它。

显然，可以使用 Python 控制台，但它有一些改进，使用户体验更愉快的功能，如历史和自动完成。

### 其他交互环境

*   bpython:python 控制台的基于诅咒的增强
*   Emacs：Emacs 文本编辑器可用于宿主 Python 会话或 IPython 会话。

### 嵌入 R 控制台

python 可以用来开发成熟的应用程序，包括具有图形用户界面的应用程序。

`rpy2`可用于提供嵌入在此类应用程序中的 R 控制台，或构建替代 R GUI。

在提供 R 控制台时，开发人员可能希望保留对处理与 R 交互的方式、控制台级别以及以交互为目标的基本 R 函数的控制（请参见[回调](callbacks.html#rinterface-callbacks)部分）。

[rpygtk 项目](http://code.google.com/p/rpygtk/)演示了如何使用`rpy2`为 r 使用 python 实现一个完整的 GUI。

## 替代接口

[rtools](http://pypi.python.org/pypi/rtools)包建议在 rpy2 中添加/自定义更高级别的接口。

`pandas &lt;http://pypi.python.org/pypi/pandas&gt;`包提议用 python 解释数据帧，绑定到 numpy 结构。提到了与 RPY2 的自定义接口，但它似乎没有项目的其他部分开发得那么多。

## 类 R 数据结构

R 的数据帧在处理数据时非常方便。在`rpy2`中，原始的 r`data.frame`由`rpy2.robjects.vectors.DataFrame`表示，但[pydataframe](http://code.google.com/p/pydataframe/)项目具有纯 Python 实现（与`rpy2`的兼容层在需要时提供无缝转换）。