# 高级接口

> 原文：[https://rpy2.readthedocs.io/en/version_2.8.x/high-level.html](https://rpy2.readthedocs.io/en/version_2.8.x/high-level.html)

*   [robjects 包](robjects.html)
    *   [概述](robjects_overview.html)
    *   [`r`：**r**](robjects_rinstance.html)的实例
        *   [将字符串计算为 R 代码](robjects_rinstance.html#evaluating-a-string-as-r-code)
    *   [r 对象](robjects_robjects.html)
    *   [环境](robjects_environments.html)
    *   [函数](robjects_functions.html)
        *   [可调用](robjects_functions.html#callable)
        *   [`rcall()`](robjects_functions.html#rcall)
        *   [文档字符串](robjects_functions.html#docstrings)
    *   [公式](robjects_formulae.html)
    *   [R 包](robjects_rpackages.html)
        *   [导入 r 包](robjects_rpackages.html#importing-r-packages)
        *   [将任意 R 代码作为包导入](robjects_rpackages.html#importing-arbitrary-r-code-as-a-package)
            *   [r 命名空间](robjects_rpackages.html#r-namespaces)
            *   [类图](robjects_rpackages.html#class-diagram)
        *   [查找 R 符号的来源](robjects_rpackages.html#finding-where-an-r-symbol-is-coming-from)
        *   [安装/删除 R 包](robjects_rpackages.html#installing-removing-r-packages)
    *   [使用 R's OOPS](robjects_oop.html)
        *   [s3 对象](robjects_oop.html#s3-objects)
        *   [S4 对象](robjects_oop.html#s4-objects)
            *   [基本处理](generated_rst/s4class.html)
            *   [将 s4 类映射到 python 类](generated_rst/s4class.html#mapping-s4-classes-to-python-classes)
                *   [自定义转换](generated_rst/s4class.html#custom-conversion)
                *   [类属性](generated_rst/s4class.html#class-attributes)
                *   [方法](generated_rst/s4class.html#methods)
            *   [手动 r-in-python 类定义](robjects_oop.html#manual-r-in-python-class-definition)
            *   [自动 r-in-python 类定义](robjects_oop.html#automated-r-in-python-class-definitions)
        *   [用户定义类的自动映射](robjects_oop.html#automated-mapping-of-user-defined-classes)
    *   [对象序列化](robjects_serialization.html)
    *   [类图](robjects.html#class-diagram)
*   [向量和数组](vector.html)
    *   [创建向量](vector.html#creating-vectors)
        *   [因子服务器](vector.html#factorvector)
    *   [提取项目](vector.html#extracting-items)
        *   [提取，python 样式](vector.html#extracting-python-style)
        *   [提取，R 样式](vector.html#extracting-r-style)
    *   [分配项目](vector.html#assigning-items)
        *   [分配，python 样式](vector.html#assigning-python-style)
        *   [分配，R 样式](vector.html#assigning-r-style)
    *   [缺少值](vector.html#missing-values)
    *   [运算符](vector.html#operators)
    *   [名称](vector.html#names)
    *   [`Array`](vector.html#array)
    *   [`Matrix`](vector.html#matrix)
        *   [矩阵计算](vector.html#computing-on-matrices)
        *   [提取](vector.html#extracting)
    *   [`DataFrame`](vector.html#dataframe)
        *   [创建对象](vector.html#creating-objects)
        *   [提取元素](vector.html#extracting-elements)
        *   [python 文档字符串](vector.html#python-docstrings)
*   [r 帮助](rhelp.html)
    *   [查询别名](rhelp.html#querying-on-aliases)
    *   [包文档](rhelp.html#package-documentation)
    *   [文档页](rhelp.html#documentation-page)
*   [将 rpy2 对象映射到任意 python 对象](robjects_convert.html)
    *   [协议](robjects_convert.html#protocols)
    *   [转换](robjects_convert.html#conversion)
        *   [转换器对象](robjects_convert.html#converter-objects)
        *   [本地转换规则](robjects_convert.html#local-conversion-rules)
        *   [`ri2ro()`](robjects_convert.html#ri2ro)
        *   [`ri2py()`](robjects_convert.html#ri2py)
        *   [`p2ri()`](robjects_convert.html#p2ri)
        *   [自定义转换](robjects_convert.html#customizing-the-conversion)
*   [图形](graphics.html)
    *   [简介](graphics.html#introduction)
        *   [图形设备](graphics.html#graphical-devices)
        *   [准备就绪](graphics.html#getting-ready)
    *   [包 _ 格 _](graphics.html#package-lattice)
        *   [简介](graphics.html#id2)
        *   [散点图](graphics.html#scatter-plot)
        *   [方框图](graphics.html#box-plot)
        *   [其他地块](graphics.html#other-plots)
    *   [包 _ggplot2_](graphics.html#package-ggplot2)
        *   [简介](graphics.html#id3)
        *   [图](graphics.html#plot)
            *   [美学映射](graphics.html#aesthethics-mapping)
            *   [几何](graphics.html#geometry)
            *   [轴](graphics.html#axes)
            *   [面](graphics.html#facets)
    *   [包 _ 网格 _](graphics.html#package-grid)
        *   [带网格的自定义 ggplot2 布局](graphics.html#custom-ggplot2-layout-with-grid)
        *   [类](graphics.html#classes)
        *   [类图](graphics.html#class-diagram)
*   [数据帧和 dplyr](lib_dplyr.html)
    *   [双唇管](lib_dplyr.html#dplyr)
    *   [python 中的 dplyr](lib_dplyr.html#dplyr-in-python)
    *   [蒂蒂尔](lib_dplyr.html#tidyr)
    *   [python 中的 tidyr](lib_dplyr.html#tidyr-in-python)